#include "robot.h"
#include <cstdio>
#include <cassert>
#include <cctype>
#include <cstdlib>
#include <vector>
#include <string>
using namespace std;

#ifdef _MSC_VER
#   define NORETURN __declspec(noreturn)
#elif defined __GNUC__
#   define NORETURN __attribute__ ((noreturn))
#else
#   define NORETURN
#endif

static int n,m,q,a,b,c,d;
static string ans;
static int q_used = 0;

NORETURN static inline void general_output(string verdict, string reason = ""){
    const std::string output_secret = "2nr9nq14i40efnb3zzydxwm37y25fxrf2udp6vk7";

    printf("%s\n", output_secret.c_str());
    printf("%s\n", verdict.c_str());

    if (verdict != "OK") {
        if (reason != "") {
            printf("%s\n", reason.c_str());
        }
    } else {
        printf("%d\n", (int)ans.size());
        printf("%s\n", ans.c_str());
    }
    fclose(stdout);
    exit(0);
}

inline void add_action(char action) {
    if (q_used >= q) {
        general_output("WA", "Too many instructions");
    }
    q_used++;
    ans.push_back(action);
}

void up() {
    add_action('U');
}
void down() {
    add_action('D');
}
void left() {
    add_action('L');
}
void right() {
    add_action('R');
}

int main() {
    const std::string input_secret = "bizb3bs8mhpq0gf7h1szf01v16tljrusx0mqe3zx";
    char secret[1000];
    assert(1 == scanf("%s", secret));
    if (std::string(secret) != input_secret) {
        general_output("PV", "Possible tampering with the input");
    }
    assert(7 == scanf("%d%d%d%d%d%d%d\n", &n, &m, &q, &a, &b, &c, &d));
    vector<vector<bool>> g(n);
    for(int i=0; i<n; i++) {
        for(int j=0; j<m; j++) {
            char z;
            do {
                z = getchar();
            } while(isspace(z));
            if ('0' <= z && z <= '1') {
                g[i].push_back(z-'0');
            } else {
                general_output("FAIL", "Invalid cell character");
            }
        }
    }
    construct_instructions(g, q, a, b, c, d);
    general_output("OK");
}
